package cn.com.ty.chat;

import lombok.extern.slf4j.Slf4j;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.web.servlet.ServletComponentScan;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.scheduling.annotation.EnableScheduling;

@Slf4j
@EnableScheduling
@EnableFeignClients
@EnableDiscoveryClient
@MapperScan("cn.com.ty.chat.mapper")
@SpringBootApplication(scanBasePackages = {"cn.com.ty.chat", "cn.com.xwy.boot"})
public class ChatApplication {
    public static void main(String[] args) {
        log.debug("ChatApplication startup main");
        SpringApplication application = new SpringApplication(ChatApplication.class);
        application.run(args);
    }
}
