package cn.com.ty.chat.mapper.entity;

import cn.com.ty.chat.base.BaseEntity;
import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 诊单
 * 
 * @author Xson
 * @date 2020-04-23
 */
@TableName(value = "lift_case")
@Data
public class LiftCaseEntity extends BaseEntity {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    /**
     * 问题描述 问题描述
     */
    private String expression;

    /**
     * 已尝试的方法 已尝试的方法
     */
    private String usedMethods;

    /**
     * 图集 图集
     */
    private String imgs;

    /**
     * 品牌 品牌id
     */
    private Integer brandId;

    /**
     * 会话id
     */
    private String sessionId;

    /**
     * 出诊地址 地图显示，gps坐标
     */
    private String address;

    /**
     * 专家 专家id
     */
    @JsonSerialize(using = ToStringSerializer.class)
    private Long chargerId;

    /**
     * 差旅费 差旅费
     */
    private BigDecimal travelCost;

    /**
     * 服务费 服务费
     */
    private BigDecimal serviceCost;

    /**
     * 总价 总价
     */
    private BigDecimal totalCost;

    /**
     * 出诊时间
     */
    private Date arrivedTime;

    /**
     * 0待付款 1已付款 2待报价 3待打卡 4已打卡（专家待确认） 6专家已确认（用户待确认） 5用户已确认 7待评论 8待归档 9已归档 10申诉中 11申诉完成 12用户确认打卡 13拒绝接单
     */
    private Integer statuz;

    private Integer acceptStatus;

    /**
     * 打卡标记 0已打卡1未打卡
     */
    private Integer arrivedFlag;

    /**
     * 打卡地点 打开地点
     */
    private String arrivedAddress;
    
    /**
     * 打卡地点 打开地点
     */
    private String lat;
    
    /**
     * 打卡地点 打开地点
     */
    private String lng;

    /**
     * 问诊出诊 1问诊2出诊
     */
    private Integer dataTable;

    @JsonSerialize(using = ToStringSerializer.class)
    private Long createUserId;

    private String beforeRepair;

    private String afterRepair;

    @JsonSerialize(using = ToStringSerializer.class)
    private Long customerServiceId;

    /**
     * 是否已开发票
     */
    private Integer isInvoice;

    /**
     * 电梯出厂日期
     */
    private String productionDate;

    /**
     * 红包抵扣
     */
    private transient BigDecimal redEnvelopeDeduction;

    /**
     * 红包id
     */
    @TableField(strategy = FieldStrategy.IGNORED)
    private Long redEnvelopeId;

    /**
     * 优惠券抵扣
     */
    private transient BigDecimal couponDeduction;

    /**
     * 优惠券id
     */
    @TableField(strategy = FieldStrategy.IGNORED)
    private Long couponId;

    /**
     * 实际支付价 实际支付价
     */
    private BigDecimal payCost;

    /**
     * 订单编号 订单编号
     */
    private String orderNo;

    /**
     * 支付方式 1:微信2:支付宝
     */
    private Integer payType;

    private String videoUrl;
    
    /**
     * 支付宝流水号
     */
    private String orderSerialNumber;

    private Integer isPlatformSpecified;

    private Integer colorGrade;

}
